routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
// App\User::create([
//     'name' => 'jegaest',
//     'email' => 'jegaest@juju.com',
//     'password' => bcrypt('test123'),
// ]);

// Listar sentencias sql en web
/*DB::listen(function($query){
    echo "<pre>{$query->sql}</pre>";
    //echo "<pre>{$query->time}</pre>";
});*/

Route::get('roles', function(){
    return \App\Role::with('user')->get();
});

Route::get('/', ['as' => 'home', 'uses' => 'PagesController@home']);
Route::get('/home', ['as' => 'home', 'uses' => 'PagesController@home']);

Route::get('saludos/{nombre?}', ['as' => 'saludos', 'uses' => 'PagesController@saludo'])->where('nombre', "[A-Za-z]+");

// Implementation for messages
Route::resource('mensajes', 'MessagesController');

// Implementation for users
Route::resource('usuarios', 'UsersController');

Route::get('login', 'Auth\LoginController@showLoginForm');
Route::post('login', 'Auth\LoginController@login')->name('login');
Route::get('logout', 'Auth\LoginController@logout');

app/User.php
<?php

namespace App;

use App\Message;
use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    public function setPasswordAttribute($password)
    {
        $this->attributes['password'] = bcrypt($password);
    }

    // Relation with role
    public function roles()
    {
        return $this->belongsToMany(Role::class, 'assigned_roles');
    }

    public function hasRoles(array $roles)
    {
        return $this->roles->pluck('name')->intersect($roles)->count();
    }

    public function isAdmin()
    {
        return $this->hasRoles(['admin']);
    }

    public function messages()
    {
        return $this->hasMany(Message::class);
    }

    public function note()
    {
        return $this->morphOne(Note::class, 'notable');
    }

    public function tags()
    {
        return $this->morphToMany(Tag::class, 'taggable')->withTimestamps();
    }
}

app/Http/Controllers/UsersController.php
<?php

namespace App\Http\Controllers;

use App\Role;
use App\User;
use Illuminate\Http\Request;
use App\Http\Requests\CreateUserRequest;
use App\Http\Requests\UpdateUserRequest;

class UsersController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth', ['except' => ['show']]);
        $this->middleware('roles:admin', ['except' => ['edit', 'update', 'show']]);
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

        $users = User::with(['roles', 'note', 'tags'])->get();

        return view('users.index', compact('users'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $roles = Role::pluck('display_name', 'id');

        return view('users.create', compact('user', 'roles'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  App\Http\Requests\CreateUserRequest $request
     * @return \Illuminate\Http\Response
     */
    public function store(CreateUserRequest $request)
    {
        $user = User::create($request->all());

        $user->roles()->attach($request->roles);

        return redirect()->route('usuarios.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $user = User::findOrFail($id);

        return view('users.show', compact('user'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $user = User::findOrFail($id);

        // using UserPolicy 
        $this->authorize('edit', $user);

        $roles = Role::pluck('display_name', 'id');

        return view('users.edit', compact('user', 'roles'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(UpdateUserRequest $request, $id)
    {
        $user = User::findOrFail($id);

        $this->authorize('update', $user);

        $user->update($request->only('name', 'email'));

        $user->roles()->sync($request->roles);

        return back()->with('info', 'Usuario actualizado');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $user = User::findOrFail($id);

        $this->authorize('destroy', $user);

        $user->delete();

        return back();
    }
}

resources/views/users/create.blade.php
@extends('layout')

@section('contenido')
    <h1>Crear Usuario</h1>
    <form method="POST" action="{{route('usuarios.store')}}">
        @include('users.form', ['user' => new App\User])
        <p><input class="btn btn-primary" type="submit" value="Guardar"></p>
    </form>
@stop

resources/views/users/edit.blade.php
@extends('layout')

@section('contenido')
    <h1>Editar Usuario</h1>
        @if( session()->has('info'))
            <div class="alert alert-success">{{ session('info') }}</div>
        @endif
        <form method="POST" action="{{route('usuarios.update', $user->id)}}">
            {!! method_field('PUT') !!}
            @include('users.form')
            <p><input class="btn btn-primary" type="submit" value="Enviar"></p>
        </form>
    <hr>
@stop

resources/views/users/form.blade.php
{!! csrf_field() !!}
<p>
    <label for="name">
        Nombre
        <input class="form-control" type="text" name="name" value="{{ $user->name or old('name') }}">
        {!! $errors->first('name', '<span class=error>:message</span>') !!}
    </label>
</p>
<p>
    <label for="email">
        Email
        <input class="form-control" type="email" name="email" value="{{ $user->email or old('email') }}">
        {!! $errors->first('email', '<span class=error>:message</span>') !!}
    </label>
</p>

@unless($user->id)
<p>
    <label for="password">
        Password
        <input class="form-control" type="password" name="password">
        {!! $errors->first('password', '<span class=error>:message</span>') !!}
    </label>
</p>
<p>
    <label for="password_confirmation">
        Password Confirm
        <input class="form-control" type="password" name="password_confirmation">
        {!! $errors->first('password_confirmation', '<span class=error>:message</span>') !!}
    </label>
</p>
@endunless

<div class="checkbox">
    @foreach( $roles as $id => $name)
        <label>
            <input 
                type="checkbox"
                value="{{ $id }}"
                {{ $user->roles()->pluck('id')->contains($id) ? 'checked' : '' }}
                name="roles[]">
            {{ $name }}
        </label>
    @endforeach
</div>
{!! $errors->first('roles', '<span class=error>:message</span>') !!}
<hr>

resources/views/users/index.blade.php
@extends('layout')

@section('contenido')
    <h1>Usuarios</h1>
    <a class="btn btn-primary pull-right" href="{{ route('usuarios.create')}} ">Crear nuevo usuario</a>
    <table class="table">
        <thead>
            <th>ID</th>
            <th>Nombre</th>
            <th>Email</th>
            <th>Role</th>
            <th>Notas</th>
            <th>Tags</th>
            <th>Acciones</th>
        </thead>
        <tbody>
            @foreach ($users as $user)
                <tr>
                    <td>{{ $user->id }}</td>
                    <td>{{ $user->name }}</td>
                    <td>{{ $user->email }}</td>
                    <td>{{ $user->roles->pluck('display_name')->implode(' - ')}}</td>
                    <td>{{ $user->note ? $user->note->body : '' }}</td>
                    <td>{{ $user->tags->pluck('nombre')->implode(', ') }}</td>
                    <td>
                        <a class="btn btn-info btn-xs" href="{{ route('usuarios.edit', $user->id) }}">Editar</a>
                        <form style="display: inline;" method="POST" action="{{route('usuarios.destroy', $user->id)}}">
                            {!! method_field('DELETE') !!}
                            {!! csrf_field() !!}
                            <button class="btn btn-danger btn-xs" type="submit">Eliminar</button>
                        </form>
                    </td>
                </tr>
            @endforeach
        </tbody>
    </table>

@stop

resources/views/users/show.blade.php
@extends('layout')

@section('contenido')
    <h1>{{ $user->name }}</h1>
    <table class="table">
        <tr>
            <th>Nombre</th>
            <td>{{ $user->name }}</td>
        </tr>
        <tr>
            <th>Email</th>
            <td>{{ $user->email }}</td>
        </tr>
        <tr>
            <th>Roles</th>
            <td>
                @foreach ($user->roles as $role)
                    {{ $role->display_name }}
                @endforeach
            </td>
        </tr>
    </table>

@can('edit', $user)
    <a class="btn btn-info" href="{{ route('usuarios.edit', $user->id) }}">Editar</a>
@endcan

@can('destroy', $user)
    <form style="display: inline;" method="POST" action="{{route('usuarios.destroy', $user->id)}}">
        {!! method_field('DELETE') !!}
        {!! csrf_field() !!}
        <button class="btn btn-danger" type="submit">Eliminar</button>
    </form>
@endcan

@stop